// Step10OLEDB.cpp : Defines the entry point for the console application.
// Step by Step Site 
// http://www.mjk.msk.ru/~dron/
// Kaev Artem 2000
//


#include "stdafx.h"
#include "iostream.h"
#include "oledb.h"      // OLE DB 
#include "oledberr.h" 


// OLE DB - ODBC 
#include "msdaguid.h"
#include "msdasql.h"
 


void main()
{

HRESULT hr;
IDBInitialize* pIDBInitialize = NULL;

//    
const ULONG   nProps = 4;
IDBProperties*  pIDBProperties;
DBPROP    InitProperties[nProps];
DBPROPSET   rgInitPropSet;
  

//  COM
if  (  FAILED(  CoInitialize(  NULL  ))) 
 {
   cout << "Unable to initialize COM" << endl;
   return ;
 }

hr=CoCreateInstance(CLSID_MSDASQL, NULL, CLSCTX_INPROC_SERVER,IID_IDBInitialize, (void **) &pIDBInitialize);
if (FAILED(hr)) 
{
      cout << "CoCreateInstance Failed" << endl;
	  CoUninitialize();
	  return;
}

//  
//   
for (ULONG i = 0; i < nProps; i++ )
{
    VariantInit(&InitProperties[i].vValue);
    InitProperties[i].dwOptions = DBPROPOPTIONS_REQUIRED;
    InitProperties[i].colid = DB_NULLID;
}
// 
InitProperties[0].dwPropertyID = DBPROP_INIT_PROMPT;
InitProperties[0].vValue.vt = VT_I2;
InitProperties[0].vValue.iVal = DBPROMPT_NOPROMPT;
// 
InitProperties[1].dwPropertyID = DBPROP_INIT_DATASOURCE;
InitProperties[1].vValue.vt = VT_BSTR;
InitProperties[1].vValue.bstrVal = SysAllocString(OLESTR("OLE_DB_NWind_Jet"));
// 
InitProperties[2].dwPropertyID = DBPROP_AUTH_USERID;
InitProperties[2].vValue.vt = VT_BSTR;
InitProperties[2].vValue.bstrVal = SysAllocString(OLESTR(""));
// 
InitProperties[3].dwPropertyID = DBPROP_AUTH_PASSWORD;
InitProperties[3].vValue.vt = VT_BSTR;
InitProperties[3].vValue.bstrVal = SysAllocString(OLESTR(""));

//  
rgInitPropSet.guidPropertySet = DBPROPSET_DBINIT;
rgInitPropSet.cProperties = nProps;
rgInitPropSet.rgProperties = InitProperties;

//   
pIDBInitialize->QueryInterface(IID_IDBProperties, (void**)&pIDBProperties);
//  
hr = pIDBProperties->SetProperties(1, &rgInitPropSet);
//  
SysFreeString(InitProperties[1].vValue.bstrVal);
SysFreeString(InitProperties[2].vValue.bstrVal);
SysFreeString(InitProperties[3].vValue.bstrVal);
//  
pIDBProperties->Release();

//    
if  (FAILED(hr)) 
 {
	cout << "Unable to set Propertes" << endl;
	pIDBInitialize->Release();
	CoUninitialize();
   return ;
 }

hr=pIDBInitialize->Initialize();
if (FAILED(hr))
{
	cout << "Unable to initialize IDBInitialize" << endl;
	switch (hr)
	{
	case DB_S_ASYNCHRONOUS:
		cout << "DB_S_ASYNCHRONOUS" << endl;
		break;
    case DB_S_ERRORSOCCURRED:
		cout << "DB_S_ERRORSOCCURRED" << endl;
		break;
    case E_FAIL:
		cout << "E_FAIL" << endl;
		break;
    case E_OUTOFMEMORY:
		cout << "E_OUTOFMEMORY" << endl;
		break;
    case E_UNEXPECTED:
		cout << "E_UNEXPECTED" << endl;
		break;
	case DB_E_ALREADYINITIALIZED:
		cout << "DB_E_ALREADYINITIALIZED" << endl;
		break;
    case DB_E_CANCELED:
		cout << "DB_E_CANCELED" << endl;
		break;
    case DB_E_ERRORSOCCURRED:
		cout << "DB_E_ERRORSOCCURRED" << endl;
		break;
    case DB_SEC_E_AUTH_FAILED:
		cout << "DB_SEC_E_AUTH_FAILED" << endl;
		break;
	default:
		cout << " ????? " << endl;
		break;
	}	
	pIDBInitialize->Release(); 
	CoUninitialize();
	return;

}
pIDBInitialize->Uninitialize();
pIDBInitialize->Release(); 
//  COM
CoUninitialize();
}

